<?php
// $Id: textsize.admin.inc,v 1.1.2.1 2009/03/11 22:19:16 christianzwahlen Exp $

/**
 * @file
 * Provides the Text Size administrative interface.
 */

/**
 * Implementation of hook_help().
 */
function textsize_help($path, $arg) {
  $path_textsize =  base_path() . drupal_get_path('module', 'textsize');
  $textsize_increment = variable_get('textsize_increment', 10);
  $link_wcag = l('Web Content Accessibility Guidelines', 'http://www.w3.org/TR/WCAG/', array('attributes' => array('title' => 'Web Content Accessibility Guidelines')));
  $link_bitv= l('bundesrecht.juris.de', 'http://bundesrecht.juris.de/bitv/anlage_8.html', array('attributes' => array('title' => 'bundesrecht.juris.de')));
  $link_ff = l('www.mozilla.com/en-US/firefox/', 'http://www.mozilla.com/en-US/firefox', array('attributes' => array('title' => 'Mozilla Firefox')));
  $link_ts = l(t('Text Size') .' '. t('Home page'), 'http://www.zwahlendesign.ch/en/node/192', array('attributes' => array('title' => t('Text Size') .' '. t('Home page'))));
  $abbr_php = '<abbr lang="en" xml:lang="en" title="PHP: Hypertext Preprocessor">PHP</abbr>';
  $abbr_mysql = '<abbr title="MySQL">MySQL</abbr>';
  $abbr_xhtml = '<abbr lang="en" xml:lang="en" title="Extensible Hypertext Markup Language">XHTML</abbr>';
  $abbr_css = '<abbr lang="en" xml:lang="en" title="Cascading Style Sheets">CSS</abbr>';
  $abbr_wcag = '<abbr lang="en xml:lang="en" title="Web Content Accessibility Guidelines">WCAG</abbr>';
  $abbr_bitv = '<abbr lang="de" xml:lang="de" title="Barrierefreie Informationstechnik-Verordnung">BITV</abbr>';
  $abbr_png = '<abbr lang="en" xml:lang="en" title="Portable Network Graphics">PNG</abbr>';
  $abbr_gif = '<abbr lang="en" xml:lang="en" title="Graphic Interchange Format">GIF</abbr>';
  switch ($path) {
    case 'admin/help#textsize':
      $output = '<p><img src="'. $path_textsize .'/images/textsize_list.png" alt="'. t('Screenshot of block:') .' '. t('Select menu') .'." class="float_right" />'. t('This module display a text size changer in a block for better web accessibility. The module is a !abbr_php module and use JavaScript if supported,  but no !abbr_mysql. Cookies are required, for saving the text size durable and in old browsers.', array('!abbr_php' =>  $abbr_php, '!abbr_mysql' =>  $abbr_mysql)) .'</p>'."\n";
      $output .= '<h3>'. t('Requirements') .'</h3>'."\n";
      $output .= '<ol>'."\n";
      $output .= '<li>'. t('Drupal Module:') .' '. l(t('jQuery plugins'), 'http://drupal.org/project/jquery_plugin') .'.</li>'."\n";
      $output .= '<li>'. t('Browser: Accept Cookies.') .'</li>'."\n";
      $output .= '<li>'. t('Browser Internet Explorer: Theme or a theme region with font sitze "em", "%" or no sitze.') .'</li>'."\n";
      $output .= '</ol>'."\n";
      $output .= '<h3>'. t('Features') .'</h3>'."\n";
      $output .= '<ul>'."\n";
      $output .= '<li>'. t('!abbr_wcag and !abbr_bitv conform. More Information on: !link_wcag and !link_bitv.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv, '!link_wcag' => $link_wcag, '!link_bitv' => $link_bitv)) .' '. t('Keep the conditions:') .' '."\n";
      $output .= '  <ol>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 1.1: Alt text in the images.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 3.1: Standard links with text and not images.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 6.3: No JavaScript rquired.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 11.1: Open and standard code.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 13.6: Links in a list.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  </ol>'."\n";
      $output .= '</li>'."\n";
      $output .= '<li>'. t('No JavaScript required. jQuery suppport.') .'</li>'."\n";
      $output .= '<li>'. t('No !abbr_css required.', array('!abbr_css' => $abbr_css)) .'</li>'."\n";
      $output .= '<li>'. t('Minimum and maximum text size.') .'</li>'."\n";
      $output .= '<li>'. t('Caching mode: "Normal" and "Aggressive" compatible.') .'</li>'."\n";
      $output .= '  <li>'. t('Block type') ."\n";
      $output .= '    <ol>'."\n";
      $output .= '    <li><a href="#ts_text" title="'. t('Block') .': '. t('Text links') .'.">'. t('Text links') .'</a> [1].</li>'."\n";
      $output .= '    <li><a href="#ts_images" title="'. t('Block') .': '. t('Image links') .'.">'. t('Image links') .'</a> [2].</li>'."\n";
      $output .= '    <li><a href="#ts_select" title="'. t('Block') .': '. t('Select menu') .'.">'. t('Select menu') .'.</a></li>'."\n";
      $output .= '    </ol>'."\n";
      $output .= '  </li>'."\n";
      $output .= '<li>'. t('Uniform markin of menu, based on the open source browser Firefox 2.0 (!link_ff).', array('!link_ff' => $link_ff)) .'</li>'."\n";
      $output .= '<li>'. t('Themable. See: textsize-text.tpl.php, textsize-image.tpl.php or textsize-form.tpl.php') .'</li>'."\n";
      $output .= '<li>'. t('Tested themes: Bluemarine, Garland.') .'</li>'."\n";
      $output .= '</ul>'."\n";
      $output .= '<hr/>'."\n";
      $output .= '<h3>'. t('Global settings') .'</h3>'."\n";
      $output .= '<h4>'. t('Block type') .'</h4>'."\n";
      $output .= '<dl>'."\n";
      $output .= '  <dt id="ts_text">'. t('Text links') .'</dt>'."\n";
      $output .= '  <dd><img src="'. $path_textsize .'/images/textsize_list.png" alt="'. t('Screenshot of block:') .' '. t('Text links') .'." class="float_right" />'. t('Images are showed with !abbr_css.', array('!abbr_css' => $abbr_css)) .' <span class="ok">'. t('Ideal for Web Accessibility.') .'</span></dd>'."\n";
      $output .= '  <dt id="ts_images">'. t('Image links') .'.</dt>'."\n";
      $output .= '  <dd><img src="'. $path_textsize .'/images/textsize_img.png" alt="'. t('Screenshot of block:') .' '. t('Image links') .'." class=""/><br />'. t('No Link text, only images in the !abbr_xhtml source code with standard 0 pixel margin.', array('!abbr_xhtml' =>  $abbr_xhtml)) .' <span class="warning">'. t('Warning: Not for: !abbr_wcag/!abbr_bitv 3.1! If JavaScript is not activated: No image change action if the cursor move over the images!', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span></dd>'."\n";
      $output .= '  <dt id="ts_select">'. t('Select menu') .'.</dt>'."\n";
      $output .= '  <dd><img src="'. $path_textsize .'/images/textsize_select.png" alt="'. t('Screenshot of block:') .' '. t('Select menu') .'." class="float_right"/></dd>'."\n";
      $output .= '</dl>'."\n";
      $output .= '<h4>'. t('Links type') .'</h4>'."\n";
      $output .= '<dl>'."\n";
      $output .= '  <dt>'. t('Variable links') .'</dt>'."\n";
      $output .= '  <dd>'. t('Bounded by the minimum and maximum text size.') .'</dd>'."\n";
      $output .= '  <dt>'. t('Fixed links') .'</dt>'."\n";
      $output .= '  <dd>'. t('Fixed links shows only 3 options for changing the text size (Increase, decrease and normal).') .'</dd>'."\n";
      $output .= '</dl>'."\n";
      $output .= '<h3>'. t('Advanced settings') .'</h3>'."\n";
      $output .= '<p>'. t('!abbr_xhtml element', array('!abbr_xhtml' =>  $abbr_xhtml)) .': '. t('Select the !abbr_xhtml element for the resize process.', array('!abbr_xhtml' =>  $abbr_xhtml)) .'</p>'."\n";
      $output .= '<p>'. t('!abbr_xhtml element class', array('!abbr_xhtml' =>  $abbr_xhtml)) .': '. t('Select the class of the !abbr_xhtml element for the resize process. Example: In the Garland theme, you can use the class "left-corner" for the content div. Standard is the textfield empty for the body element.', array('!abbr_xhtml' =>  $abbr_xhtml)) .'</p>'."\n";
      $output .= '<p>'. t('Increases/decreases step') .': '. t('Percentage by which each click increases/decreases the text size. The default increases/decreases step is 10&#037;.') .'</p>'."\n";
      $output .= '<p>'. t('Text Size Normal') .': '. t('The default normal text size is 100&#037;.') .'</p>'."\n";
      $output .= '<p>'. t('Minimum text size') .': '. t("The minimum default text size is 50&#037;.") .'</p>'."\n";
      $output .= '<p>'. t('Maximum text size') .': '. t("The maximum default text size is 150&#037;.") .'</p>'."\n";
      $output .= '<h3>'. t('Theme settings') .'</h3>'."\n";
      $output .= '<p>'. t('List display') .': '. t('Set the display of the list.') .' '. t('Style') .': '. t('Normal') .'/'. t('Inline.') .'</p>'."\n";
      $output .= '<p>'. t('Text display') .': '. t('By hide text in the links, it shows only the images.') .' '. t('Hide text in the links') .': <span class="warning">'. t('Warning: Not for links with images in the !abbr_xhtml source code.', array('!abbr_xhtml' =>  $abbr_xhtml)) .'</span></p>'."\n";
      $output .= '<p>'. t('Current text size display') .': '. t('By hide current text size, it shows no text.') .'</p>'."\n";
      $output .= '<h4>'. t('Overriding themable output') .'</h4>'."\n";
      $output .= '<p>'. t('Copy the files files textsize-text.tpl.php, textsize-image.tpl.php and textsize-form.tpl.php, textsize.css and the directory "images" in your theme and edit it.') .'</p>'."\n";
      $output .= '<p>'. t('You can also download edited templates from the developers website: !link_ts.', array('!link_ts' => $link_ts)) .'</p>'."\n";
      $output .= '<h5>'. t('Example:') .' "'. t('Image links, not in a list') .'"</h5>'."\n";
      $output .= '<p><img src="'. $path_textsize .'/images/textsize_img2.png" alt="'. t('Screenshot of block:') .' '. t('Image links, not in a list') .'." class="float_right"/>'. t('Change the following elements:') .'<br /><del>&#060;ul&#062;/&#060;/ul&#062;</del> '. t('to') .': <ins>&#060;p&#062;/&#060;/p&#062;</ins><br /> <del>&#060;li&#062;&#060;/li&#062;</del> '. t('to') .': <ins>&#060;span class="display_hidden"&#062;&#160;&#124;&#160;&#060;/span&#062;</ins>.<br /><span class="info">'. t('!abbr_wcag/!abbr_bitv 10.5: Adjacent hyperlinks have to be separated by printable characters surrounded by spaces.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span><br /><span class="warning">'. t('Warning: Not for: !abbr_wcag/!abbr_bitv 13.6! Links are not in a list.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span></p>'."\n";
      $output .= '<hr/>'."\n";
      $output .= '<h3>'. t('Important informations') .'</h3>'."\n";
      $output .= '<p class="warning">'. t('Warning: For Internet Explorer: Your theme have to use font sitze with "em" or "%", not pixel or points!') .'</p>'."\n";
      $output .= '<p>'. t('If you are using a theme with "font-size 0.9em" in the CSS (like the garland theme), set the text size normal to 90% or delete the "font-size" and "line-height" values for the body in your theme.') .'</p>'."\n";
      $output .= '<h4>'. t('Solutions for static themes') .'</h4>'."\n";
      $output .= '<dl>'."\n";
      $output .= '<dt>'. t('Define theme regions for the resize process') .'</dt>'."\n";
      $output .= '<dd>'. t('Example Garland theme: Select the !abbr_xhtml element "div" and define a class like "left-corner".', array('!abbr_xhtml' =>  $abbr_xhtml)) .'</dd>'."\n";
      $output .= '<dt>'. t('Edit themes') .'</dt>'."\n";
      $output .= '<dd>'. t('Example Garland theme: Open the file "themes/garland/style.css" and edit the code on line 15 for the body element. Delete the code:') ."\n";
      $output .= ' <code><del>font: 12px/170% Verdana, sans-serif; line-height:1.5;</del></code>, '."\n";
      $output .=  t('Add the following code:') ."\n";
      $output .= ' <code><ins>font-family: Verdana, sans-serif;</ins></code></dd>'."\n";
      $output .= '</dl>'."\n";
      $output .= '<h3>'. t('Source') .'</h3>'."\n";
      $output .= '<p>'. t('The !abbr_png and !abbr_gif images are in the directory "/textsize/images/" and the source file in "/textsize/images/source/".', array('!abbr_png' =>  $abbr_png, '!abbr_gif' =>  $abbr_gif)) .'</p>'."\n";
      $output .= '<p>[1] '. t('No images in the code (!abbr_css generated), only one link text (for example "Increase").', array('!abbr_css' => $abbr_css)) .'</p>'."\n";
      $output .= '<p>[2] '. t('!abbr_png images for new browsers and !abbr_gif images for old browsers (Internet Explorer 6).', array('!abbr_png' =>  $abbr_png, '!abbr_gif' =>  $abbr_gif)) .'</p>'."\n";
      return $output;
    break;
  }
}

/**
 * Builds and returns the textsize settings form.
 *
 * @ingroup forms
 * @see textsize_admin_settings_validate()
 */
function textsize_admin_settings() {
  $abbr_xhtml = '<abbr lang="en" xml:lang="en" title="Extensible Hypertext Markup Language">XHTML</abbr>';
  $abbr_css = '<abbr lang="en" xml:lang="en" title="Cascading Style Sheets">CSS</abbr>';
  $abbr_wcag = '<abbr lang="en xml:lang="en" title="Web Content Accessibility Guidelines">WCAG</abbr>';
  $abbr_bitv = '<abbr lang="de" xml:lang="de" title="Barrierefreie Informationstechnik-Verordnung">BITV</abbr>';
  $form['textsize'] = array(
    '#type' => 'fieldset',
    '#title' => t('Global settings'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  $form['textsize']['textsize_block_type'] = array(
    '#type' => 'radios',
    '#title' => t('Block type'),
    '#options' => array(
      'text' => t('Text links') .' [1]',
      'image' => t('Image links') .' [2]',
      'select' => t('Select menu'),
    ),
    '#default_value' => variable_get('textsize_block_type', 'text'),
    '#description' => t('Select the type of block.') .'&#160;<br />[1] '. t('Images are showed with !abbr_css.', array('!abbr_css' =>  $abbr_css)) .' <span class="ok">'. t('Ideal for Web Accessibility.') .'</span><br />[2] '. t('Images in the !abbr_xhtml source code.', array('!abbr_xhtml' =>  $abbr_xhtml)) .' <span class="warning">'. t('Warning: Not for: !abbr_wcag/!abbr_bitv 3.1! No hover action if JavaScript is not activated!', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span>',
  );
  $form['textsize']['textsize_link_type'] = array(
    '#type' => 'radios',
    '#title' => t('Links type'),
    '#options' => array(
      '' => t('Variable links'),
      '_fix' => t('Fixed links') .' [4]',
    ),
    '#default_value' => variable_get('textsize_link_type', ''),
    '#description' => t('Select the type of links.') .'<br />[4] '. t('Fixed links shows only 3 options for changing the text size (Increase, decrease and normal).'),
  );
  $form['textsize_adv'] = array(
    '#type' => 'fieldset',
    '#title' => t('Advanced settings'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  $form['textsize_adv']['textsize_element'] = array(
    '#type' => 'select',
    '#title' => t('!abbr_xhtml element', array('!abbr_xhtml' =>  $abbr_xhtml)),
    '#options' => array(
      'body' => 'body',
      'div' => 'div',
      'p' => 'p',
      'span' => 'span',
      'table' => 'table',
      'tr' => 'tr',
      'th' => 'th',
      'td' => 'td',
    ),
    '#default_value' => variable_get('textsize_element', 'body'),
    '#description' => t('Select the !abbr_xhtml element for the resize process. Standard is "body" for the whole page.', array('!abbr_xhtml' =>  $abbr_xhtml)),
  );
  $form['textsize_adv']['textsize_element_class'] = array(
    '#type' => 'textfield',
    '#title' => t('!abbr_xhtml element class', array('!abbr_xhtml' =>  $abbr_xhtml)),
    '#default_value' => variable_get('textsize_element_class', ''),
    '#description' => t('Select the class of the !abbr_xhtml element for the resize process. Example: In the Garland theme, you can use the class "left-corner" for the content div. Standard is the textfield empty for the body element.', array('!abbr_xhtml' =>  $abbr_xhtml)),
  );
  $form['textsize_adv']['textsize_increment'] = array(
    '#type' => 'select',
    '#title' => t('Increases/decreases step'),
    '#options' => textsize_increment_form_options(),
    '#default_value' => variable_get('textsize_increment', 10),
    '#description' => t("Percentage by which each click increases/decreases the text size. The default increases/decreases step is 10&#037;.")
  );
  $form['textsize_adv']['textsize_normal'] = array(
    '#type' => 'select',
    '#title' => t('Text Size Normal'),
    '#default_value' => variable_get('textsize_normal', 100),
    '#options' => textsize_settings_form_options(),
    '#description' => t("The default normal text size is 100&#037;.")
  );
  $form['textsize_adv']['textsize_minimum'] = array(
    '#type' => 'select',
    '#title' => t('Minimum text size'),
    '#options' => textsize_minimum_form_options(),
    '#default_value' => variable_get('textsize_minimum', 50),
    '#description' => t("The minimum default text size is 50&#037;."),
  );
  $form['textsize_adv']['textsize_maximum'] = array(
    '#type' => 'select',
    '#title' => t('Maximum text size'),
    '#options' => textsize_maximum_form_options(),
    '#default_value' => variable_get('textsize_maximum', 150),
    '#description' => t("The maximum default text size is 150&#037;.")
  );
  $form['textsize_theme'] = array(
    '#type' => 'fieldset',
    '#title' => t('Theme settings'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  $form['textsize_theme']['textsize_list_inline'] = array(
    '#type' => 'radios',
    '#title' => t('List display'),
    '#options' => array(
      '' => t('Normal'),
      '_inline' => t('Inline'),
    ),
    '#default_value' => variable_get('textsize_list_inline', ''),
    '#description' => t('Set the display of the list.'),
  );
  $form['textsize_theme']['textsize_display_links'] = array(
    '#type' => 'radios',
    '#title' => t('Text display'),
    '#options' => array(
      '' => t('Show text in the links'),
      'display_hidden' => t('Hide text in the links') .' [5]',
    ),
    '#default_value' => variable_get('textsize_display_links', ''), // default to show text links.
    '#description' => t('By hide text in the links, it shows only the images.') .' <br/> <span class="warning">[5] '. t('Warning: Not for links with images in the !abbr_xhtml source code.', array('!abbr_xhtml' =>  $abbr_xhtml)) .'</span>',
  );
  $form['textsize_theme']['textsize_display_current_textsize'] = array(
    '#type' => 'radios',
    '#title' => t('Current text size display'),
    '#options' => array(
      '' => t('Show current text size'),
      'display_hidden' => t('Hide current text size'),
    ),
    '#default_value' => variable_get('textsize_display_current_textsize', ''), // default to show current text size
    '#description' => t('By hide current text size, it shows no text.'),
  );
  return system_settings_form($form);
}

/**
 * Validate the textsize settings form.
 *
 * @see textsize_admin_settings()
 */
function textsize_admin_settings_validate($form, &$form_state) {
  if ($form_state['values']['textsize_element'] === "body" && $form_state['values']['textsize_element_class'] !== "") {
    form_set_error('textsize_element_class', t('The element class have to be empty for the body element.'));
  }
  if ($form_state['values']['textsize_element'] !== "body" && $form_state['values']['textsize_element_class'] === "") {
    form_set_error('textsize_element_class', t('The element class can not be empty. Use for example "left-corner".'));
  }
  if ($form_state['values']['textsize_increment'] > ($form_state['values']['textsize_normal'] - $form_state['values']['textsize_minimum'])) {
    form_set_error('textsize_increment', t('The text size increase step is bigger than the minimum text size.'));
  }
  if ($form_state['values']['textsize_increment'] > ($form_state['values']['textsize_maximum'] - $form_state['values']['textsize_normal'])) {
    form_set_error('textsize_increment', t('The text size increase step is bigger than the maximum text size.'));
  }
  if ($form_state['values']['textsize_minimum'] >= $form_state['values']['textsize_normal']) {
    form_set_error('textsize_minimum', t('The minimum text size can not be the same or bigger value than the normal textsize.'));
  }
  if ($form_state['values']['textsize_maximum'] <= $form_state['values']['textsize_normal']) {
    form_set_error('textsize_maximum', t('The maximum text size can not be the same or bigger value than the normal textsize.'));
  }
}

/**
 * Returns an array of available values for the select element in text size increment.
 *
 * @return
 *   An array of available values, for selecting the text size increment.
 * @see textsize_admin_settings()
 */
function textsize_increment_form_options() {
  $textsize_increment = variable_get('textsize_increment', 10);
  $textsize_normal = variable_get('textsize_normal', 100);
  $textsize_minimum = variable_get('textsize_minimum', 50);
  $textsize_maximum = variable_get('textsize_maximum', 150);
  $textsize_start = ($textsize_normal - $textsize_minimum); // 5
  $textsize_end = ($textsize_maximum - $textsize_normal); // 190
  $options = array();
  for ($value = 5; $value <= $textsize_end; $value = $value + 5 ) {
    $options[$value] = $value;
  };
  return $options;
}

/**
 * Returns an array of available values for the select element in text size minimum.
 *
 * @return
 *   An array of available values, for selecting the text size minimum.
 * @see textsize_admin_settings()
 */
function textsize_minimum_form_options() {
  $options = array();
  for ($value = 5; $value <= 190; $value = $value + 5 ) {
    $options[$value] = $value;
  };
  return $options;
}

/**
 * Returns an array of available values for the select element in text size maximum.
 *
 * @return
 *   An array of available values, for selecting the text size maximum.
 * @see textsize_admin_settings()
 */
function textsize_maximum_form_options() {
  $options = array();
  for ($value = 15; $value <= 200; $value = $value + 5 ) {
    $options[$value] = $value;
  };
  return $options;
}

/**
 * Returns an array of available values for the select element in text size normal.
 *
 * @return
 *   An array of available values, for selecting the text size normal.
 * @see textsize_admin_settings()
 */
function textsize_settings_form_options() {
  $textsize_increment = variable_get('textsize_increment', 10);
  $textsize_normal = variable_get('textsize_normal', 100);
  $textsize_minimum = variable_get('textsize_minimum', 50);
  $textsize_maximum = variable_get('textsize_maximum', 150);
  $textsize_start = (2 * $textsize_increment);
  $textsize_end = ($textsize_maximum - $textsize_increment);
  $options = array();
  for ($value = $textsize_start; $value <= $textsize_end; $value = $value + $textsize_increment ) {
    $options[$value] = $value;
  };
  return $options;
}
