<?php
// $Id: textsize-text.tpl.php,v 1.1.2.1 2009/02/01 18:54:40 christianzwahlen Exp $

/**
 * @file
 * Default theme implementation for rendering a block.
 *
 * Available variables:
 * - $dest: The drupal function drupal_get_destination().
 * - $list_inline: Display the ul list "inline" or not.
 * - $link_type: Return "" for variable or _fix.
 * - $display_links: Show or hide ("display_hidden") the text in the links.
 * - $increment: The increment step (default 10%).
 * - $normal: The textsize normal (default 100%).
 * - $display_current_textsize: Show or hide ("display_hidden") the text of the current textsize.
 * - $textsize: The current text size (default 100%).
 *
 * @see template_preprocess_textsize_text()
 */
?>
<ul class="textsize<?php print $list_inline; ?>">
  <li class="ts_increase<?php print check_plain($link_type); ?>"><?php print l('<span class="'. $display_links .'">'. t('Increase') .'</span>', 'textsize/increase', array('attributes' => array('title' => t('Text Size') .': '. t('Increase') .' +'. $increment .'%', 'class' => 'icon ts_increase'. $link_type .' textsize_increase'), 'query' => $dest, 'html' => TRUE)); ?></li>
  <li class="ts_decrease<?php print check_plain($link_type); ?>"><?php print l('<span class="'. $display_links .'">'. t('Decrease') .'</span>', 'textsize/decrease', array('attributes' => array('title' => t('Text Size') .': '. t('Decrease') .' -'. $increment .'%', 'class' => 'icon ts_decrease'. $link_type .' textsize_decrease'), 'query' => $dest, 'html' => TRUE)); ?></li>
  <li><?php print l('<span class="'. $display_links .'">'. t('Normal') .'</span>', 'textsize/normal', array('attributes' => array('title' => t('Text Size') .': '. t('Normal') .' ='. $normal .'%', 'class' => 'icon ts_normal'. $link_type .' textsize_normal'), 'query' => $dest, 'html' => TRUE)); ?></li>
</ul>
<p class="<?php print $display_current_textsize; ?>"><?php print t('Current Size'); ?>: <span id="textsize_current"><?php print $textsize; ?>%</span></p>